#ifndef CHIP_SDRAM_H
#define CHIP_SDRAM_H


/* макросы для задания временных параметров SDRAM */
#define CHIP_Q24_8_FP(x) ((x) * 256)
#define CHIP_SDRAM_T_NS(x)   CHIP_Q24_8_FP(x)
#define CHIP_SDRAM_T_CLK(x)  CHIP_Q24_8_FP(-(x))


/* Поля "Mode Register" у SDRAM */
#define CHIP_SDRAM_REGFLD_MODE_BURST_LEN            (0x07UL << 0)
#define CHIP_SDRAM_REGFLDVAL_MODE_BURST_LEN_1       0
#define CHIP_SDRAM_REGFLDVAL_MODE_BURST_LEN_2       1
#define CHIP_SDRAM_REGFLDVAL_MODE_BURST_LEN_4       2
#define CHIP_SDRAM_REGFLDVAL_MODE_BURST_LEN_8       3
#define CHIP_SDRAM_REGFLDVAL_MODE_BURST_LEN_PAGE    7

#define CHIP_SDRAM_REGFLD_MODE_BURST_TYPE           (0x01UL << 3)
#define CHIP_SDRAM_REGFLDVAL_MODE_BURST_TYPE_SEQ    0 /* Sequential */
#define CHIP_SDRAM_REGFLDVAL_MODE_BURST_TYPE_ILEAV  1 /* Interleaved */

#define CHIP_SDRAM_REGFLD_MODE_CAS_LATENCY          (0x07UL << 4)
#define CHIP_SDRAM_REGFLDVAL_MODE_CAS_LATENCY_2     2
#define CHIP_SDRAM_REGFLDVAL_MODE_CAS_LATENCY_3     3

#define CHIP_SDRAM_REGFLD_MODE_OPMODE              (0x03UL << 7)
#define CHIP_SDRAM_REGFLDVAL_MODE_OPMODE_STD       0

#define CHIP_SDRAM_REGFLD_MODE_WR_BURST            (0x01UL << 9)
#define CHIP_SDRAM_REGFLDVAL_MODE_WR_BURST_PROG    0
#define CHIP_SDRAM_REGFLDVAL_MODE_WR_BURST_SINGLE  1

#endif // CHIP_SDRAM_H
